//
//  RefreshControl.h
//  RefreshControl
//
//  Created by mave on 1/29/13.
//  Copyright (c) 2013 Sibers. All rights reserved.
//

#import <UIKit/UIKit.h>

#import <QuartzCore/QuartzCore.h>

typedef enum
{
    RefreshLocationTop = 0,
    RefreshLocationBottom = 1
}RefreshLocation;

@interface ACRefreshControl : UIControl <UIGestureRecognizerDelegate>
{
    CAShapeLayer *_shapeLayer;
    CAShapeLayer *_arrowLayer;
    CAShapeLayer *_highlightLayer;
    UIView *_activity;
    BOOL _refreshing;
    BOOL _canRefresh;
    BOOL _ignoreInset;
    BOOL _ignoreOffset;
    BOOL _didSetInset;
    BOOL _hasSectionHeaders;
    CGFloat _lastOffset;
    UIColor * _tintColor;
    RefreshLocation _refreshLocation;
}

@property (nonatomic, readonly) BOOL refreshing;
@property (nonatomic, strong) UIColor *tintColor;
@property (nonatomic, assign) UIActivityIndicatorViewStyle activityIndicatorViewStyle;
@property (nonatomic, strong) UIColor *activityIndicatorViewColor; // iOS5 or more
@property (nonatomic, assign) RefreshLocation refreshLocation;

- (id)initInScrollView:(UIScrollView *)scrollView location:(RefreshLocation)location;
- (id)initInScrollView:(UIScrollView *)scrollView activityIndicatorView:(UIView *)activity location:(RefreshLocation)location;

// Tells the control that a refresh operation was started programmatically
- (void)beginRefreshing;

// Tells the control the refresh operation has ended
- (void)endRefreshing;
@end