//
//  BaseTableViewController.m
//  TeKtoTut
//
//  Created by mave on 12/4/12.
//
//

#import "BaseTableViewController.h"

#import "ActivityView.h"
#import "TableView.h"

@implementation BaseTableViewController
{
    ACRefreshControl * _refreshControl;
}

#pragma mark - lifecycle
- (void)viewDidLoad
{
    [super viewDidLoad];
    [self addObserver];
    _activityView = [[ActivityView alloc]init];
    
    if(!_hideRefreshControl) {
        _refreshControl = [[ACRefreshControl alloc]initInScrollView:_tableView location:_refreshLocation];
        [_refreshControl addTarget:self action:@selector(updateContent) forControlEvents:UIControlEventValueChanged];
    }
}

- (void)dealloc
{
    [self removeObserver];
}

#pragma mark - Updating methods
- (void)updateContent
{
    [self showActivityView];
}

- (void)contentUpdated
{
    [self hideActivityView];
    [_refreshControl endRefreshing];
}

#pragma mark - Activity view methods
- (void)showActivityView
{
    /*if(![_tableView.subviews containsObject:_activityView]) {
        [_tableView addSubview:_activityView];
    }
    _activityView.center = CGPointMake(CGRectGetMidX(_tableView.bounds), CGRectGetMidY(_tableView.bounds));
    [_activityView startAnimating];*/
}

- (void)hideActivityView
{
    /*[_activityView stopAnimating];
    [_activityView removeFromSuperview];*/
}

#pragma mark - notification methods
- (void)addObserver
{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(tableViewReloaded:) name:kTableViewReloadedNotification object:nil];
}

- (void)removeObserver
{
    [[NSNotificationCenter defaultCenter] removeObserver:self name:kTableViewReloadedNotification object:nil];
}

- (void)tableViewReloaded:(id)notification
{
    NSInteger numOfRows = 0;
    NSInteger sectionsCount = [_tableView numberOfSections];
    for(NSInteger section = 0; section < sectionsCount; section++) {
        NSInteger rowsInSection = [_tableView numberOfRowsInSection:section];
        for(NSInteger row = 0; row < rowsInSection; row++) {
            numOfRows ++;
        }
    }
    if(!numOfRows) {
        if(_emptyView && ![_tableView.subviews containsObject:_emptyView]) {
            [_tableView addSubview:_emptyView];
        }
    }
    else {
        if(_emptyView && [_tableView.subviews containsObject:_emptyView]) {
            [_emptyView removeFromSuperview];
        }
    }
}

@end
