//
//  LoginViewController.m
//  TeKtoTut
//
//  Created by mave on 2/19/13.
//
//

#import "LoginViewController.h"

#import "VKWebViewController.h"
#import "NavigationController.h"
#import "APIRequest.h"
#import "ServerRequest.h"

@implementation LoginViewController

#pragma mark - Actions
- (IBAction)loginButtonAction:(id)sender
{
    VKWebViewController *controller = [VKWebViewController authRequestController];
    controller.delegate = (id<VKControllerDelegate>)self;
    [self.navigationController pushViewController:controller animated:YES];
}

- (IBAction)cancelButtonAction:(id)sender
{
    if([_delegate respondsToSelector:@selector(didCancelLogin)]) {
        [_delegate didCancelLogin];
    }
}

#pragma mark - lifecycle
- (void)viewDidLoad
{
    [super viewDidLoad];
    UIBarButtonItem *cancel = [[UIBarButtonItem alloc]initWithTitle:NSLocalizedString(@"Назад", @"Назад") style:UIBarButtonItemStylePlain target:self action:@selector(cancelButtonAction:)];
    self.navigationItem.leftBarButtonItem = cancel;
}

#pragma mark - VKControllerDelegate
- (void)didCancelLogin
{
    [self cancelButtonAction:nil];
}

- (void)didLoginWithVKID:(NSInteger)vkID vkToken:(NSString *)vkToken
{
    NSString *requestString = [NSString stringWithFormat:@"%@?vk_id=%d&vk_access_token=%@",kVKAuthRequestURL,vkID,vkToken];
    NSURL *url = [NSURL URLWithString:requestString];
    ServerRequest *serverRequest = [ServerRequest requestWithURL:url
                                                   requestMethod:RequestMethodGet
                                                 responseHandler:^(id response, NSError *error) {
                                                     if(!error) {
                                                         NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
                                                         [defaults setObject:vkToken forKey:kVKAccessTokenKey];
                                                         [defaults synchronize];

                                                         NSDictionary *responseDictionary = [response objectForKey:@"response"];
                                                         NSString *serverAccessToken = [responseDictionary objectForKey:@"access_token"];
                                                         NSInteger serverUID = [[responseDictionary objectForKey:@"uid"] integerValue];
                                                         if(serverUID && serverAccessToken) {
                                                             if([_delegate respondsToSelector:@selector(didLoginWithServerID:serverToken:)]) {
                                                                 [_delegate didLoginWithServerID:serverUID serverToken:serverAccessToken];
                                                             }
                                                         }
                                                     }
                                                     else {
                                                         UIAlertView *alertView = [[UIAlertView alloc]initWithTitle:nil message:error.localizedDescription delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil, nil];
                                                         [alertView show];
                                                     }
                                                 }];
    [serverRequest startConnection];
}
@end
