//
//  NavigationController.m
//  TeKtoTut
//
//  Created by Admin on 01.12.12.
//
//

#import "NavigationController.h"

@implementation NavigationController

#pragma mark - initialization
- (void)customizeNavigationBar
{
    [self.navigationBar setBackgroundImage:[UIImage imageNamed:@"bar (butto selected, back)l.png"] forBarMetrics:UIBarMetricsDefault];
    NSDictionary *dictionary = [NSDictionary dictionaryWithObjectsAndKeys:
                                [UIColor blackColor],       UITextAttributeTextColor,
                                [UIColor lightTextColor],   UITextAttributeTextShadowColor,
                                [NSValue valueWithUIOffset:UIOffsetMake(1, -1)], UITextAttributeTextShadowOffset, nil];
    [self.navigationBar setTitleTextAttributes:dictionary];
}

- (id)initWithRootViewController:(UIViewController *)rootViewController
{
    self = [super initWithRootViewController:rootViewController];
    if(self) {
        [self customizeNavigationBar];
    }
    return self;
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super initWithCoder:aDecoder];
    if(self) {
        [self customizeNavigationBar];
    }
    return self;
}

#pragma mark - IOS 6.0 rotation support
- (NSUInteger)supportedInterfaceOrientations
{
    return [self.topViewController supportedInterfaceOrientations];
}

- (UIInterfaceOrientation)preferredInterfaceOrientationForPresentation
{
    return [self.topViewController preferredInterfaceOrientationForPresentation];
}

- (BOOL)shouldAutorotate
{
    return [self.topViewController shouldAutorotate];
}

#pragma mark - IOS prior 6.0 rotation support
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)toInterfaceOrientation
{
    return [self.topViewController shouldAutorotateToInterfaceOrientation:toInterfaceOrientation];
}

@end
