//
//  PeopleLinksViewController.m
//  TeKtoTut
//
//  Created by Admin on 16.12.12.
//
//

#import "PeopleLinksViewController.h"

#import "WebBrowserViewController.h"

@implementation PeopleLinksViewController

#pragma mark - initialization
- (id)initWithLinks:(NSArray *)links
{
    self = [super initWithNibName:@"PeopleLinksViewController" bundle:nil];
    if(self) {
        _links = [NSArray arrayWithArray:links];
    }
    return self;
}

#pragma mark - UITableView DataSource
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return _links.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *kReuseIdentifier = @"Reuse Identifier";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:kReuseIdentifier];
    if(!cell) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:kReuseIdentifier];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }
    cell.textLabel.text = [_links objectAtIndex:indexPath.row];
    cell.detailTextLabel.text = NSLocalizedString(@"vkontakte", @"vkontakte");
    return cell;
}

#pragma mark - UITableViewDelegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    NSURL *url = [NSURL URLWithString:[_links objectAtIndex:indexPath.row]];
    WebBrowserViewController *controller = [[WebBrowserViewController alloc]initWithURL:url];
    [self.navigationController pushViewController:controller animated:YES];
}

@end
