//
//  PeoplesViewController.m
//  TeKtoTut
//
//  Created by mave on 1/23/13.
//
//

#import "SavedPeoplesViewController.h"

#import "ObjectsList.h"
#import "APIRequest.h"
#import "PeoplesList.h"
#import "PlaceDetailViewController.h"
#import "PeoplesViewController.h"
#import "AppDelegate.h"
#import "MenuContainerViewController.h"

@implementation SavedPeoplesViewController
{
    NSMutableArray * _loadedGuests;
}
#pragma mark - Actions
- (IBAction)menuButtonAction:(id)sender
{
    [[AppDelegate delegate].menuController showMenu];
}

#pragma mark - working methods
- (void)createLeftButton
{
    UIImage *normalImage = [UIImage imageNamed:@"button.png"];
    UIImage *pushedImaged = [UIImage imageNamed:@"button_pushed.png"];
    
    UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
    button.frame = CGRectMake(0, 0, normalImage.size.width, normalImage.size.height);
    [button setBackgroundImage:normalImage forState:UIControlStateNormal];
    [button setBackgroundImage:pushedImaged forState:UIControlStateHighlighted];
    [button addTarget:self action:@selector(menuButtonAction:) forControlEvents:UIControlEventTouchUpInside];
    
    UIBarButtonItem *item = [[UIBarButtonItem alloc]initWithCustomView:button];
    self.navigationItem.leftBarButtonItem = item;
}

#pragma mark - lifecycle
- (void)viewDidLoad
{
    [super viewDidLoad];
    _loadedGuests = [NSMutableArray array];
    [self createLeftButton];
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    [self updateContent];
}

#pragma mark - super class ovveriden methods
- (void)updateContent
{
    [super updateContent];
    [APIRequest loadSavedGuestsWithResponseHandler:^(NSArray *guests) {
        [_loadedGuests removeAllObjects];
        [_loadedGuests addObjectsFromArray:guests];
        [super contentUpdated];
        dispatch_async(dispatch_get_main_queue(), ^{
            [_tableView reloadData];
        });
    }];
}

#pragma mark - UITableViewDataSource
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return _loadedGuests.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *kReuseIdentifier = @"Reuse Identifier";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:kReuseIdentifier];
    if(!cell) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:kReuseIdentifier];
        cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
    }
    PeoplesList *list = [_loadedGuests objectAtIndex:indexPath.row];
    cell.textLabel.text = list.name;
    return cell;
}

#pragma mark - UITableViewDelegate
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
    PeoplesList *list = [_loadedGuests objectAtIndex:indexPath.row];
    [APIRequest loadPlacePeoplesWithID:list.peopleListID responseHandler:^(NSArray *peoples) {
        dispatch_async(dispatch_get_main_queue(), ^{
            PeoplesViewController *controller = [[PeoplesViewController alloc]initWithPeoples:peoples];
            [self.navigationController pushViewController:controller animated:YES];
        });
    }];
}
@end
