//
//  SettingsViewController.m
//  TeKtoTut
//
//  Created by Admin on 26/01/2013.
//
//

#import "SettingsViewController.h"


#import "AppDelegate.h"
#import "MenuContainerViewController.h"

enum
{
    TableViewRowVKWallPost = 0,
    TableViewRowsCount
};

@implementation SettingsViewController

#pragma mark - Actions
- (IBAction)wallPostSwitchValue:(UISwitch *)sender
{
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    [defaults setObject:[NSNumber numberWithBool:sender.on] forKey:kWallPostEnableKey];
    [defaults synchronize];
}

- (IBAction)menuButtonAction:(id)sender
{
    [[AppDelegate delegate].menuController showMenu];
}

#pragma mark - lifecycle
- (void)viewDidLoad
{
    [super viewDidLoad];
    [self createLeftButton];
}

#pragma mark - working methods
- (void)createLeftButton
{
    UIImage *normalImage = [UIImage imageNamed:@"button.png"];
    UIImage *pushedImaged = [UIImage imageNamed:@"button_pushed.png"];
    
    UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
    button.frame = CGRectMake(0, 0, normalImage.size.width, normalImage.size.height);
    [button setBackgroundImage:normalImage forState:UIControlStateNormal];
    [button setBackgroundImage:pushedImaged forState:UIControlStateHighlighted];
    [button addTarget:self action:@selector(menuButtonAction:) forControlEvents:UIControlEventTouchUpInside];
    
    UIBarButtonItem *item = [[UIBarButtonItem alloc]initWithCustomView:button];
    self.navigationItem.leftBarButtonItem = item;
}


#pragma mark - UITableViewDataSource
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return TableViewRowsCount;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString * const kReuseIdentifier = @"ReuseIdentifier";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:kReuseIdentifier];
    if(!cell) {
        cell = [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:kReuseIdentifier];
        cell.accessoryType = UITableViewCellAccessoryNone;
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
    }
    switch (indexPath.row) {
        case TableViewRowVKWallPost: {
            cell.textLabel.font = [UIFont boldSystemFontOfSize:14.0];
            cell.textLabel.text = NSLocalizedString(@"Отключить посты на стену", "Отключить посты на стену");
            UISwitch *switchView = [[UISwitch alloc]init];
            [switchView addTarget:self action:@selector(wallPostSwitchValue:) forControlEvents:UIControlEventValueChanged];
            BOOL isVKPostEnabled = [[[NSUserDefaults standardUserDefaults] objectForKey:kWallPostEnableKey] boolValue];
            [switchView setOn:isVKPostEnabled];
            cell.accessoryView = switchView;
        }
            break;
            
        default: {
            NSAssert(NO, @"Unknown cell");
        }
            break;
    }
    return cell;
}

@end
