//
//  APIRequest.h
//  TeKtoTut
//
//  Created by Admin on 01.12.12.
//
//

#import <Foundation/Foundation.h>

@class Place;
@class People;

#pragma mark - Request address
#define ServerAddress  @"http://d.tektotut.ru"
static NSString  * const kPlacesRequestURL          = ServerAddress@"/android/places/search";
static NSString  * const kPlacePeoplesRequestURL    = ServerAddress@"/android/places/getpeople";
static NSString  * const kPlaceUpdateInfoRequestURL = ServerAddress@"/android/places/getinfo";
static NSString  * const kPlaceCheckinRequest       = ServerAddress@"/android/places/checkin";
static NSString  * const kVKAuthRequestURL          = ServerAddress@"/android/users/vk_auth2";
static NSString  * const kGetPeopleInfoRequestURL   = ServerAddress@"/android/users/getinfo";
static NSString  * const kGetPeopleImagesRequestURL = ServerAddress@"/android/users/getphotos";
static NSString  * const kSetAvatarRequestURL       = ServerAddress@"/android/users/set_avatar";
static NSString  * const kDeletePhotoRequestURL     = ServerAddress@"/android/users/delete_photo";
static NSString  * const kUploadPhotoRequestURL     = ServerAddress@"/android/users/upload_photo";
static NSString  * const kDialogsRequestURL         = ServerAddress@"/android/messages/get_dialogs";
static NSString  * const kMessagesRequestURL        = ServerAddress@"/android/messages/get";
static NSString  * const kMessageSendURL            = ServerAddress@"/android/messages/send";
static NSString  * const kSavePlaceGuestsURL        = ServerAddress@"/android/guests/save";
static NSString  * const kLoadSavedGuestsURL        = ServerAddress@"/android/guests/getlist";
static NSString  * const kLoadPlacePeoplesURL       = ServerAddress@"/android/guests/getinfo";
static NSString  * const kUpdatePeopleInfoURL       = ServerAddress@"/android/users/update_info";
static NSString  * const kMarkMessageAsReadURL      = ServerAddress@"/android/messages/mark_as_read";
static NSString  * const kUpdatePushTokenURL        = ServerAddress@"/android/users/update_ios_token";

@interface APIRequest : NSObject

+ (void)updatePlaceInfoForPlace:(Place *)place responseHandler:(dispatch_block_t)handler;
+ (void)checkinRequestForPlace:(Place *)place responseHandler:(dispatch_block_t)handler;
+ (void)requestPeopleForPlace:(Place *)place responseHandler:(void (^)(NSArray *peoples)) handler;
+ (void)requestPeopleInfoForId:(NSInteger)peopleID responseHandler:(void (^)(People *people)) handler;
+ (void)requestPeopleImagesForId:(NSInteger)peopleID responseHandler:(void (^)(NSArray *images))handler;
+ (void)setAvatarRequestWithImageID:(NSInteger)imageID;
+ (void)deletePhotoRequestWithImageID:(NSInteger)imageID responseHandler:(dispatch_block_t)handler;
+ (void)uploadPhotoWithURLs:(NSArray *)array responseHandler:(dispatch_block_t)handler;
+ (void)sendMessageWithSenderID:(NSInteger)senderID messageText:(NSString *)text responseHandler:(void (^)(BOOL success)) handler;
+ (void)savePlaceGuests:(NSInteger)placeID;
+ (void)loadSavedGuestsWithResponseHandler:(void (^)(NSArray *guests))handler;
+ (void)loadPlacePeoplesWithID:(NSInteger)listID responseHandler:(void(^)(NSArray *peoples))handler;
+ (void)updatePeopleInfo:(People *)peopleInfo;
+ (void)markAsReadMessageWithID:(NSInteger)messageID responseHandler:(void (^)(BOOL success)) handler;
+ (void)updatePushNotificationToken:(NSString *)tokenString;

+ (NSString *)signedRequest:(NSString *)requestString withParams:(BOOL)hasParams;
@end
