//
//  Conversation.m
//  TeKtoTut
//
//  Created by Admin on 16.12.12.
//
//

#import "Conversation.h"

#import "NSString+NotNilAppend.h"
#import "NSString+MD5.h"
#import "ImageDownloader.h"
#import "APIRequest.h"

@implementation Conversation

#pragma mark - NSCoding protocol
- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [aCoder encodeInteger:_conversationID forKey:@"ConversationID"];
    [aCoder encodeObject:_peopleName forKey:@"name"];
    [aCoder encodeObject:_lastMessage forKey:@"lastMessage"];
    [aCoder encodeObject:_lastMessageDate forKey:@"lastMessageDate"];
    [aCoder encodeObject:_peopleImageURL forKey:@"peopleImage"];
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];
    if(self) {
        self.conversationID = [aDecoder decodeIntegerForKey:@"ConversationID"];
        self.peopleName = [aDecoder decodeObjectForKey:@"name"];
        self.lastMessage = [aDecoder decodeObjectForKey:@"lastMessage"];
        self.lastMessageDate = [aDecoder decodeObjectForKey:@"lastMessageDate"];
        self.peopleImageURL = [aDecoder decodeObjectForKey:@"peopleImage"];
    }
    return self;
}

#pragma mark - initialization
- (id)initWithDictionary:(NSDictionary *)dictionary
{
    self = [super init];
    if(self) {
        NSDictionary *userDictionary = [dictionary objectForKey:@"user"];
        self.conversationID = [[userDictionary objectForKey:@"uid"]integerValue];
        self.peopleName = @"";
        self.peopleName = [self.peopleName appendNotNilString:[userDictionary objectForKey:@"first_name"]];
        self.peopleName = [self.peopleName appendNotNilString:@" "];
        self.peopleName = [self.peopleName appendNotNilString:[userDictionary objectForKey:@"last_name"]];
        self.lastMessage = [dictionary objectForKey:@"body"];
        //self.lastMessageDate = ;
        self.peopleImageURL = [userDictionary objectForKey:@"photo"];
        self.peopleID = [[userDictionary objectForKey:@"uid"]integerValue];
    }
    return self;
}

@end