//
//  Place.m
//  TeKtoTut
//
//  Created by Admin on 01.12.12.
//
//

#import "Place.h"

@interface Place()
@property (nonatomic, readwrite) NSInteger   placeID;
@property (nonatomic, readwrite) NSString *  name;
@property (nonatomic, readwrite) NSString *  address;
@property (nonatomic, readwrite) NSString *  mac;
@property (nonatomic, readwrite) NSString *  phone;
@property (nonatomic, readwrite) NSString *  site;
@property (nonatomic, readwrite) NSString *  imageURL;
@property (nonatomic, readwrite) float       lat;
@property (nonatomic, readwrite) float       lon;
@property (nonatomic, readwrite) float       distance;
@property (nonatomic, readwrite) NSInteger   males;
@property (nonatomic, readwrite) NSInteger   females;
@property (nonatomic, readwrite) BOOL        checkin;
@property (nonatomic, readwrite) BOOL        visibility;
@property (nonatomic, readwrite) NSString *  info;

@end

@implementation Place

/*#pragma mark - NSCoding
- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [aCoder encodeInteger:self.placeID forKey:@"PlaceID"];
    [aCoder encodeObject:self.name forKey:@"name"];
    [aCoder encodeObject:self.address forKey:@"address"];
    [aCoder encodeObject:self.mac forKey:@"mac"];
    [aCoder encodeObject:self.phone forKey:@"phone"];
    [aCoder encodeObject:self.site forKey:@"site"];
    [aCoder encodeObject:self.imageURL forKey:@"image"];
    [aCoder encodeFloat:self.lat forKey:@"lat"];
    [aCoder encodeFloat:self.lon forKey:@"lon"];
    [aCoder encodeFloat:self.distance forKey:@"distance"];
    [aCoder encodeInteger:self.males forKey:@"male"];
    [aCoder encodeInteger:self.females forKey:@"female"];
    [aCoder encodeBool:self.checkin forKey:@"checkin"];
    [aCoder encodeBool:self.visibility forKey:@"visibility"];
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];
    if(self) {
        self.placeID = [aDecoder decodeIntegerForKey:@"PlaceID"];
        self.name = [aDecoder decodeObjectForKey:@"name"];
        self.address = [aDecoder decodeObjectForKey:@"address"];
        self.mac = [aDecoder decodeObjectForKey:@"mac"];
        self.phone = [aDecoder decodeObjectForKey:@"phone"];
        self.site = [aDecoder decodeObjectForKey:@"site"];
        self.imageURL = [aDecoder decodeObjectForKey:@"image"];
        self.lat = [aDecoder decodeFloatForKey:@"lat"];
        self.lon = [aDecoder decodeFloatForKey:@"lon"];
        self.distance = [aDecoder decodeFloatForKey:@"distance"];
        self.males = [aDecoder decodeIntegerForKey:@"male"];
        self.females = [aDecoder decodeIntegerForKey:@"female"];
        self.checkin = [aDecoder decodeBoolForKey:@"checkin"];
        self.visibility = [aDecoder decodeBoolForKey:@"visibility"];
    }
    return self;
}*/

- (id)initWithDictionary:(NSDictionary *)dictionary
{
    self = [super init];
    if(self) {
        [self updateWithDictionary:dictionary];
    }
    return self;
}

- (void)updateWithDictionary:(NSDictionary *)dictionary
{
    if(dictionary) {
        self.placeID = [[dictionary objectForKey:@"id"] integerValue];
        self.name = [dictionary objectForKey:@"name"];
        self.address = [dictionary objectForKey:@"address"];
        self.mac = [dictionary objectForKey:@"mac"];
        self.phone = [dictionary objectForKey:@"phone"];
        self.site = [dictionary objectForKey:@"site"];
        self.imageURL = [dictionary objectForKey:@"image"];
        self.lat = [[dictionary objectForKey:@"lat"]floatValue];
        self.lon = [[dictionary objectForKey:@"lon"]floatValue];
        self.distance = [[dictionary objectForKey:@"distance"]floatValue];
        self.males = [[dictionary objectForKey:@"male"]integerValue];
        self.females = [[dictionary objectForKey:@"female"]integerValue];
        self.checkin = [[dictionary objectForKey:@"checkin"]boolValue];
        self.visibility = [[dictionary objectForKey:@"visibility"]boolValue];
        self.info = [dictionary objectForKey:@"info"];
    }
}
@end
