//
//  ServerRequest.m
//  TeKtoTut
//
//  Created by Admin on 08.12.12.
//
//

#import "ServerRequest.h"

@implementation ServerRequest

- (void)preprocessResponse: (id) response
{
    id object = [NSJSONSerialization JSONObjectWithData:response options:0 error:nil];
    NSString *string = [[NSString alloc]initWithData:response encoding:NSUTF8StringEncoding];
    if([object isKindOfClass:[NSDictionary class]]) {
        NSDictionary *error = [object objectForKey:@"error"];
        id responseObject = [object objectForKey:@"response"];
        if(responseObject) {
            if([responseObject isKindOfClass:[NSArray class]]) {
                NSArray *arrayResponse = responseObject;
                if(arrayResponse.count)  {
                    [self succeedWithResponse:object];
                }
                else {
                    NSInteger code = [[error objectForKey:@"code"] integerValue];
                    [self failWithError:[[NSError alloc]initWithDomain:@"ServerErrorDomain" code:code userInfo:nil]];
                }
            }
            else if([responseObject isKindOfClass:[NSDictionary class]]) {
                NSDictionary *dictionaryResponse = responseObject;
                if(dictionaryResponse.count) {
                    [self succeedWithResponse:object];
                }
                else {
                    NSInteger code = [[error objectForKey:@"code"] integerValue];
                    [self failWithError:[[NSError alloc]initWithDomain:@"ServerErrorDomain" code:code userInfo:nil]];
                }
            }
            else if(!error){
                [self succeedWithResponse:object];
            }
            else {
                NSInteger code = [[error objectForKey:@"code"] integerValue];
                [self failWithError:[[NSError alloc]initWithDomain:@"ServerErrorDomain" code:code userInfo:nil]];
            }
        }
        else {
            NSInteger code = [[error objectForKey:@"code"] integerValue];
            [self failWithError:[[NSError alloc]initWithDomain:@"ServerErrorDomain" code:code userInfo:nil]];
        }
    }
    else {
        NSError *error = [[NSError alloc]initWithDomain:@"Response is not NSDictionary type" code:kPreprocessErrorCode userInfo:nil];
        [self failWithError:error];
    }
}


- (NSError *)errorFromResponse:(id)response
{
    NSError *error = [[NSError alloc]initWithDomain:[response objectForKey:@"text"] code:[[response objectForKey:@"code"]integerValue] userInfo:nil];
    return error;
}
@end
