//
//  ConversationTableViewCell.m
//  TeKtoTut
//
//  Created by Admin on 16.12.12.
//
//

#import "ConversationTableViewCell.h"

#import <QuartzCore/QuartzCore.h>

#import "Conversation.h"

@implementation ConversationTableViewCell

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {        
        _peopleImageView = [[UIImageView alloc]initWithFrame:CGRectMake(10, 10, 50, 60)];
        _peopleImageView.contentMode = UIViewContentModeScaleAspectFit;
        _peopleImageView.backgroundColor = [UIColor clearColor];
        [self.contentView addSubview:_peopleImageView];
        
        _peopleNameLabel = [[UILabel alloc]initWithFrame:CGRectMake(70, 20, 145, 20)];
        _peopleNameLabel.font = [UIFont boldSystemFontOfSize:12.0];
        _peopleNameLabel.backgroundColor = [UIColor clearColor];
        [self.contentView addSubview:_peopleNameLabel];
        
        _dateLabel = [[UILabel alloc]initWithFrame:CGRectMake(220, 20, 90, 20)];
        _dateLabel.font = [UIFont systemFontOfSize:11.0];
        _dateLabel.backgroundColor = [UIColor clearColor];
        [self.contentView addSubview:_dateLabel];
        
        _messageLable = [[UILabel alloc]initWithFrame:CGRectMake(70, 40, 230, 20)];
        _messageLable.font = [UIFont systemFontOfSize:10.0];
        _messageLable.backgroundColor = [UIColor clearColor];
        [self.contentView addSubview:_messageLable];
    }
    return self;
}

- (void)setupCellForConversation:(Conversation *)conversation
{
    _peopleNameLabel.text = conversation.peopleName;
    _messageLable.text = conversation.lastMessage;
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
    [formatter setDateStyle:NSDateFormatterShortStyle];
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    _dateLabel.text = [formatter stringFromDate:conversation.lastMessageDate];
}

- (void)setPeoplImage:(UIImage *)image
{
    if(image) {
        _peopleImageView.image = image;
    }
    else {
        _peopleImageView.image = [UIImage imageNamed:@"noimage.gif"];
    }
}
@end