//
//  ImagesTableViewCell.m
//  TeKtoTut
//
//  Created by Admin on 08.12.12.
//
//

#import "ImagesTableViewCell.h"

@implementation ImagesTableViewCell


- (UIImageView *)imageViewWithFrame:(CGRect)frame
{
    UIImageView *imageView = [[UIImageView alloc]initWithFrame:frame];
    imageView.contentMode = UIViewContentModeScaleAspectFit;
    imageView.userInteractionEnabled = YES;
    return imageView;
}


- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        UITapGestureRecognizer *rec1 = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(firstImageSelected:)];
        _firstImageView = [self imageViewWithFrame:CGRectMake(5, 5, 100, 100)];
        [_firstImageView addGestureRecognizer:rec1];
        
        UITapGestureRecognizer *rec2 = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(secongImageSelected:)];
        _secondImageView = [self imageViewWithFrame:CGRectMake(110, 5, 100, 100)];
        [_secondImageView addGestureRecognizer:rec2];
        
        UITapGestureRecognizer *rec3 = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(thirdImageSelected:)];
        _thirdImageView = [self imageViewWithFrame:CGRectMake(215, 5, 100, 100)];
        [_thirdImageView addGestureRecognizer:rec3];
        
        self.frame = CGRectMake(self.frame.origin.x, self.frame.origin.y, self.frame.size.width, 110);
    }
    return self;
}

- (void)setImage:(UIImage *)image imagePosition:(CellImagePosition)position;
{
    switch (position) {
        case CellImagePositionLeft: {
            _firstImageView.image = image;
            if(![self.contentView.subviews containsObject:_firstImageView]) {
                [self.contentView addSubview:_firstImageView];
            }
        }
            break;
        case CellImagePositionCenter: {
            _secondImageView.image = image;
            if(![self.contentView.subviews containsObject:_secondImageView]) {
                [self.contentView addSubview:_secondImageView];
            }
        }
            break;
        case CellImagePositionRight: {
            _thirdImageView.image = image;
            if(![self.contentView.subviews containsObject:_thirdImageView]) {
                [self.contentView addSubview:_thirdImageView];
            }
        }
            break;
            
        default: {
            NSAssert(NO, @"Wrong CellImagePosition");
        }
            break;
    }
}

- (void)setImageViewSelected:(BOOL)selected imageViewPosition:(CellImagePosition)position
{
    switch (position) {
        case CellImagePositionLeft: {
            if(selected) {
                UIView *whiteView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, 20, 20)];
                whiteView.backgroundColor = [UIColor greenColor];
                [_firstImageView addSubview:whiteView];
            }
            else {
                [_firstImageView.subviews makeObjectsPerformSelector:@selector(removeFromSuperview)];
            }
        }
            break;
        case CellImagePositionCenter: {
            if(selected) {
                UIView *whiteView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, 20, 20)];
                whiteView.backgroundColor = [UIColor greenColor];
                [_secondImageView addSubview:whiteView];
            }
            else {
                [_secondImageView.subviews makeObjectsPerformSelector:@selector(removeFromSuperview)];
            }
        }
            break;
        case CellImagePositionRight: {
            if(selected) {
                UIView *whiteView = [[UIView alloc]initWithFrame:CGRectMake(0, 0, 20, 20)];
                whiteView.backgroundColor = [UIColor greenColor];
                [_thirdImageView addSubview:whiteView];
            }
            else {
                [_thirdImageView.subviews makeObjectsPerformSelector:@selector(removeFromSuperview)];
            }
        }
            break;
            
        default: {
            NSAssert(NO, @"Wrong CellImagePosition");
        }
            break;
    }
}

- (void)prepareForReuse
{
    [_firstImageView.subviews makeObjectsPerformSelector:@selector(removeFromSuperview)];
    [_firstImageView removeFromSuperview];
    [_secondImageView.subviews makeObjectsPerformSelector:@selector(removeFromSuperview)];
    [_secondImageView removeFromSuperview];
    [_thirdImageView.subviews makeObjectsPerformSelector:@selector(removeFromSuperview)];
    [_thirdImageView removeFromSuperview];
}

#pragma mark - Actions
- (void)firstImageSelected:(id)sender
{
    if([_delegate respondsToSelector:@selector(didSelectImageOnPosition:inCell:)]) {
        [_delegate didSelectImageOnPosition:CellImagePositionLeft inCell:self];
    }
}

- (void)secongImageSelected:(id)sender
{
    if([_delegate respondsToSelector:@selector(didSelectImageOnPosition:inCell:)]) {
        [_delegate didSelectImageOnPosition:CellImagePositionCenter inCell:self];
    }
}

- (void)thirdImageSelected:(id)sender
{
    if([_delegate respondsToSelector:@selector(didSelectImageOnPosition:inCell:)]) {
        [_delegate didSelectImageOnPosition:CellImagePositionRight inCell:self];
    }
}
@end
