//
//  MessageTableViewCell.m
//  TeKtoTut
//
//  Created by mave on 1/10/13.
//
//

#import "MessageTableViewCell.h"

#import "Message.h"

@implementation MessageTableViewCell

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        _currentUserMessageLabel = [UILabel new];
        _currentUserMessageLabel.numberOfLines = 0;
        _currentUserMessageLabel.textAlignment = NSTextAlignmentLeft;
        _currentUserMessageLabel.font = [UIFont systemFontOfSize:14.0];
        _currentUserMessageLabel.backgroundColor = [UIColor clearColor];
        [self.contentView addSubview:_currentUserMessageLabel];
        
        _someUserMessageLabel = [UILabel new];
        _someUserMessageLabel.numberOfLines = 0;
        _someUserMessageLabel.textAlignment = NSTextAlignmentLeft;
        _someUserMessageLabel.font = [UIFont systemFontOfSize:14.0];
        _someUserMessageLabel.backgroundColor = [UIColor clearColor];
        [self.contentView addSubview:_someUserMessageLabel];
        
        _messageImageView = [[UIImageView alloc]init];
        [self.contentView addSubview:_messageImageView];
    }
    return self;
}

- (void)setMessage:(Message *)message forCurrentUserID:(NSInteger)currentUserID
{
    if(message.senderID == currentUserID) {
        [self.contentView bringSubviewToFront:_currentUserMessageLabel];
        _currentUserMessageLabel.text = message.text;
        _someUserMessageLabel.text = nil;
        UIImage *image = [[UIImage imageNamed:@"bubble1.png"] resizableImageWithCapInsets:UIEdgeInsetsMake(20, 20, 20, 20)];
        _messageImageView.image = image;
    }
    else {
        [self.contentView bringSubviewToFront:_someUserMessageLabel];
        _someUserMessageLabel.text = message.text;
        _currentUserMessageLabel.text = nil;
        UIImage *image = [[UIImage imageNamed:@"bubble2.png"] resizableImageWithCapInsets:UIEdgeInsetsMake(20, 20, 20, 20)];
        _messageImageView.image = image;
    }
    [self setNeedsLayout];
    [self layoutIfNeeded];
}

- (void)prepareForReuse
{
    [super prepareForReuse];
    _currentUserMessageLabel.text = nil;
    _someUserMessageLabel.text = nil;
}

- (void)layoutSubviews
{
    [super layoutSubviews];
    if(_currentUserMessageLabel.text && ![_currentUserMessageLabel.text isEqualToString:@""]) {
        UILabel *label = _currentUserMessageLabel;
        CGSize size = [label.text sizeWithFont:label.font constrainedToSize:CGSizeMake(250, 100000)];
        CGRect frame = CGRectMake(15, 5, size.width, size.height);
        label.frame = frame;
        frame.origin.x -= 10;
        frame.origin.y -= 5;
        frame.size.width += 15;
        frame.size.height += 10;
        _messageImageView.frame = frame;
        self.frame = CGRectMake(self.frame.origin.x, self.frame.origin.y, self.frame.size.width, size.height + 10);
    }
    else {
        UILabel *label = _someUserMessageLabel;
        CGSize size = [label.text sizeWithFont:label.font constrainedToSize:CGSizeMake(250, 100000)];
        CGRect  frame = CGRectMake(305 - size.width, 5, size.width, size.height);
        label.frame = frame;
        frame.origin.x -= 5;
        frame.origin.y -= 5;
        frame.size.width += 15;
        frame.size.height += 10;
        _messageImageView.frame = frame;
        self.frame = CGRectMake(self.frame.origin.x, self.frame.origin.y, self.frame.size.width, size.height + 10);
    }
}
@end
