//
//  PartsControl.m
//  TeKtoTut
//
//  Created by Admin on 15/02/2013.
//
//

#import "PartsControl.h"

@implementation PartsControl

#pragma mark - Actions
- (void)rightPartTaped:(UITapGestureRecognizer *)recognizer
{
    if(_selectionState != PartsControlSelectionStateRight) {
        [self setSelectionState:PartsControlSelectionStateRight];
    }
}

- (void)leftPartTaped:(UITapGestureRecognizer *)recognizer
{
    if(_selectionState != PartsControlSelectionStateLeft) {
        [self setSelectionState:PartsControlSelectionStateLeft];
    }
}

#pragma mark - initialization
- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self customizeView];
    }
    return self;
}

- (id)init
{
    self = [super init];
    if(self) {
        [self customizeView];
    }
    return self;
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super initWithCoder:aDecoder];
    if(self) {
        [self customizeView];
    }
    return self;
}

- (void)customizeView
{
    self.frame = CGRectMake(self.frame.origin.x, self.frame.origin.x, 122, 31);
    
    self.backgroundColor = [UIColor clearColor];    
    _imageView = [[UIImageView alloc]initWithFrame:self.bounds];
    [self addSubview:_imageView];
    
    
    _leftLabel = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, 61, 31)];
    _leftLabel.backgroundColor = [UIColor clearColor];
    _leftLabel.font = [UIFont systemFontOfSize:12.0];
    _leftLabel.textAlignment = NSTextAlignmentCenter;
    _leftLabel.userInteractionEnabled = YES;
    [self addSubview:_leftLabel];
    
    _rightLabel = [[UILabel alloc]initWithFrame:CGRectMake(61, 0, 61, 31)];
    _rightLabel.backgroundColor = [UIColor clearColor];
    _rightLabel.font = [UIFont systemFontOfSize:12.0];
    _rightLabel.textAlignment = NSTextAlignmentCenter;
    _rightLabel.userInteractionEnabled = YES;
    [self addSubview:_rightLabel];
    
    UITapGestureRecognizer *tap1 = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(leftPartTaped:)];
    [_leftLabel addGestureRecognizer:tap1];
    UITapGestureRecognizer *tap2 = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(rightPartTaped:)];
    [_rightLabel addGestureRecognizer:tap2];
    
    [self setSelectionState:PartsControlSelectionStateLeft];
}

#pragma mark - UIView methods
- (void)setFrame:(CGRect)frame
{
    [super setFrame:frame];
    _imageView.frame = self.bounds;
}

#pragma mark - property methods
- (void)setRightTitle:(NSString *)rightTitle
{
    _rightLabel.text = rightTitle;
}

- (void)setLeftTitle:(NSString *)leftTitle
{
    _leftLabel.text = leftTitle;
}

- (NSString *)leftTitle
{
    return _leftLabel.text;
}

- (NSString *)rightTitle
{
    return _rightLabel.text;
}

- (void)setSelectionState:(PartsControlSelectionState)selectionState
{
    _selectionState = selectionState;
    switch (_selectionState) {
        case PartsControlSelectionStateLeft: {
            _imageView.image = [UIImage imageNamed:@"selected2.png"];
        }
            break;
        case PartsControlSelectionStateRight: {
            _imageView.image = [UIImage imageNamed:@"selected1l.png"];
        }
            break;
            
        default: {
            NSAssert(NO, @"Unknown Selection State");
        }
            break;
    }
    [self sendActionsForControlEvents:UIControlEventValueChanged];
}

- (PartsControlSelectionState)selectionState
{
    return _selectionState;
}
@end
