//
//  PeopleHeaderView.m
//  TeKtoTut
//
//  Created by Admin on 08.12.12.
//
//

#import "PeopleInfoTableViewCell.h"

#import "People.h"

@implementation PeopleInfoTableViewCell

- (UILabel *)labelWithFrame:(CGRect)frame
{
    UILabel *label = [[UILabel alloc]initWithFrame:frame];
    label.font = [UIFont systemFontOfSize:15.0];
    label.numberOfLines = 1.0;
    label.backgroundColor = [UIColor clearColor];
    return label;
}

#pragma mark - inititalization
- (void)customizeView
{
    _peopleSexLabel = [self labelWithFrame: CGRectMake(20, 10, 280, 20)];
    [self.contentView addSubview:_peopleSexLabel];
    
    _peopleBirthDateLabel = [self labelWithFrame: CGRectMake(20, 30, 280, 20)];
    [self addSubview:_peopleBirthDateLabel];
    
    _peopleWebsiteLabel = [self labelWithFrame: CGRectMake(20, 50, 280, 20)];
    [self.contentView addSubview:_peopleWebsiteLabel];
    
    _peopleVKLabel = [self labelWithFrame: CGRectMake(20, 70, 280, 20)];
    [self.contentView addSubview:_peopleVKLabel];
    
    self.contentView.frame = CGRectMake(self.contentView.frame.origin.x, self.contentView.frame.origin.y, self.contentView.frame.size.width, 100);
}

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if(self) {
        [self customizeView];
    }
    return self;
}

#pragma mark - working methods
- (void)setViewForPeople:(People *)people
{
    _peopleSexLabel.text = [NSLocalizedString(@"Пол: ", @"Пол: ") appendNotNilString:people.sex];
    NSDateFormatter *formatter = [[NSDateFormatter alloc]init];
    [formatter setDateStyle:NSDateFormatterLongStyle];
    [formatter setTimeStyle:NSDateFormatterNoStyle];
    NSString *dateString = [formatter stringFromDate:people.birthDate];;
    _peopleBirthDateLabel.text = [NSLocalizedString(@"Дата рождения: ", @"Дата рождения: ") appendNotNilString:dateString];
    _peopleWebsiteLabel.text = [NSLocalizedString(@"Сайт: ", @"Сайт: ") appendNotNilString:people.website];
    _peopleVKLabel.text = NSLocalizedString(@"VK: ", @"VK: ");
    _peopleVKLabel.text = [_peopleVKLabel.text appendNotNilString:people.vkPage];
}

@end