//
//  PeopleMainInfoCell.m
//  TeKtoTut
//
//  Created by Admin on 11/02/2013.
//
//

#import "PeopleMainInfoCell.h"

#import "People.h"
#import "UIImageView+RemoteImage.h"
#import "APIRequest.h"

@implementation PeopleMainInfoCell

- (UILabel *)labelWithFrame:(CGRect)frame
{
    UILabel *label = [[UILabel alloc]initWithFrame:frame];
    label.font = [UIFont systemFontOfSize:15.0];
    label.numberOfLines = 1.0;
    label.backgroundColor = [UIColor clearColor];
    return label;
}

#pragma mark - inititalization
- (void)customizeView
{
    _peopleImageView = [[UIImageView alloc]initWithFrame:CGRectMake(20, 10, 50, 50)];
    _peopleImageView.contentMode = UIViewContentModeScaleAspectFit;
    [self.contentView addSubview:_peopleImageView];
    
    _peopleNameLabel = [self labelWithFrame: CGRectMake(80, 15, 220, 20)];
    [self.contentView addSubview:_peopleNameLabel];
    
    _peopleLastCheckinLabel = [self labelWithFrame: CGRectMake(80, 40, 220, 20)];
    [self addSubview:_peopleLastCheckinLabel];
    
    self.contentView.frame = CGRectMake(self.contentView.frame.origin.x, self.contentView.frame.origin.y, self.contentView.frame.size.width, 60);
}

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if(self) {
        [self customizeView];
    }
    return self;
}

#pragma mark - working methods
- (void)setViewForPeople:(People *)people
{
    _peopleNameLabel.text = people.firstName;
    [_peopleImageView loadImageViewURL:people.photoURL];
    _peopleLastCheckinLabel.text = [NSLocalizedString(@"Заходил(а): ", @"Заходил(а): ") appendNotNilString:nil];
}

- (void)setPeopleImage:(UIImage *)peopleImage
{
    if(!peopleImage) {
        UIImage *image = [UIImage imageNamed:@"noimage.gif"];
        _peopleImageView.image = image;
    }
    else {
        _peopleImageView.image = peopleImage;
    }
}
@end
