//
//  PlaceCell.m
//  iOpen
//
//  Created by алко on 9/18/12.
//  Copyright (c) 2012 company. All rights reserved.
//

#import "PlaceCell.h"

#import "Place.h"
#import "UIImageView+RemoteImage.h"
#import "APIRequest.h"
#import "ActivityView.h"
#import "LocationManager.h"

@implementation PlaceCell
{
    ActivityView *_actView;
}

- (void)setupCellForPlace:(Place *)place
{
    _placeNameLabel.text = place.name;;
    _placeAddressLabel.text = place.address;
    _maleCounterLabel.text = [NSString stringWithFormat:@"%d",place.males];
    _femaleCounterLabel.text = [NSString stringWithFormat:@"%d",place.females];
    _placeImageView.image = nil;
    
    
    if([LocationManager locationServicesEnabled]) {
        CLLocation *location = [[CLLocation alloc]initWithLatitude:place.lat longitude:place.lon];
        CLLocation *currentLocation = [LocationManager currentLocation];
        float distance = [currentLocation distanceFromLocation:location];
        float kmDistance = distance / 1000;
        _distanceLabel.text = [NSString stringWithFormat:@"%.2f",kmDistance];
    }
    else {
        _distanceLabel.text = nil;
    }
}

- (void)setPlaceImage:(UIImage *)image
{
    if(image) {
        _placeImageView.backgroundColor = [UIColor clearColor];
    }
    else {
        _placeImageView.backgroundColor = [UIColor colorWithPatternImage:[UIImage imageNamed:@"blue_pattern.jpg"]];
    }
    _placeImageView.image = image;
}

- (void)loadImageForPlace:(Place *)place
{
    [_placeImageView loadImageViewURL:[NSString stringWithFormat:@"%@%@",ServerAddress,place.imageURL]];
}

/*#pragma mark - loading methods
- (BOOL)isLoadingImage
{
    return (_actView != nil);
}

- (void)createLoadingView
{
    _actView = [[ActivityView alloc]init];
    [self addSubview:_actView];
    _actView.center = CGPointMake(CGRectGetMidX(_placeImageView.frame), CGRectGetMidY(_placeImageView.frame));
}

- (void)hideLoadingView
{
    [_actView removeFromSuperview];
    _actView = nil;
}
 */
@end
